// $Id: LoKiCore.h 182776 2015-01-19 12:31:55Z ibelyaev $
// ============================================================================
// Include files 
// ============================================================================
// LoKiCore
// ============================================================================
#include "LoKi/Functors.h"
#include "LoKi/Math.h"
#include "LoKi/Operators.h"
#include "LoKi/RangeList.h"
#include "LoKi/Constants.h"
#include "LoKi/CoreTypes.h"
#include "LoKi/Helpers.h"
#include "LoKi/Base.h"
#include "LoKi/Monitoring.h"
#include "LoKi/Info.h"
#include "LoKi/ExtraInfo.h"
#include "LoKi/Filters.h"
#include "LoKi/Sources.h"
#include "LoKi/Streamers.h"
// ============================================================================
/** @file
 *
 *  This file is a part of LoKi project - 
 *    "C++ ToolKit  for Smart and Friendly Physics Analysis"
 *
 *  The package has been designed with the kind help from
 *  Galina PAKHLOVA and Sergey BARSUK.  Many bright ideas, 
 *  contributions and advices from G.Raven, J.van Tilburg, 
 *  A.Golutvin, P.Koppenburg have been used in the design.
 *
 *  @author Vanya BELYAEV ibelyaev@physics.syr.edu
 *  @date 2006-11-25 
 */
// ============================================================================
/** @namespace LoKi 
 *  The major namespace for all LoKi project
 *  all classes, functions and onbjects (Except for operators)
 *  are places inside this namespace
 *  @author Vanya BELYAEV ibelyaev@physics.syr.edu
 *  @date 2001-01-23 
 */
namespace LoKi
{
  namespace Algs       {} 
  namespace Cast       {}
  namespace Adapters   {}
  namespace Constants  {}
  namespace Kinematics {}
  namespace Geometry   {}
  namespace Particles  {}  
  namespace Types      {}
  namespace Cuts       {}
  namespace Objects    {}
  namespace Monitoring {}
} // end of namespace LoKi
// ============================================================================
// The END 
// ============================================================================
